; compact decoder ISR for quad encoders

#include <avr/io.h>

.extern enc_delta
.extern enc_last
.global TIMER0_COMPA_vect

/*  define IO pins for phase A & B */

#define PHASE_A_PORT    PINC
#define PHASE_A_BIT     PC1
#define PHASE_B_PORT    PINC
#define PHASE_B_BIT     PC2
/*
TIMER0_COMPA_vect:
    push    r16
    push    r17
    in      r16, _SFR_IO_ADDR(SREG)
    push    r16

    ldi     r16, 0
    ldi     r17, 1
    sbic    _SFR_IO_ADDR(PHASE_A_PORT), PHASE_A_BIT
    ldi     r16, 3
    sbic    _SFR_IO_ADDR(PHASE_B_PORT), PHASE_B_BIT
    eor     r16, r17
    lds     r17, enc_last
    sub     r17, r16
    sbrs    r17, 0
    rjmp    TIMER0_COMPA_vect_end
    sts     enc_last, r16
    andi    r17, 2
    subi    r17, 1
    lds     r16, enc_delta
    add     r16, r17
    sts     enc_delta, r16
TIMER0_COMPA_vect_end:

    pop     r16
    out     _SFR_IO_ADDR(SREG), r16 
    pop     r17
    pop     r16
	reti
*/
